/* debug console - receiving string and echo it - for debug */

#include <stdio.h>
#include <stdlib.h>

#include "debug_console.h"




static void
die(const char* const message)
{
	puts(message);
	exit(EXIT_FAILURE);
}




static LRESULT CALLBACK
window_procedure(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	COPYDATASTRUCT* cds;

	if (msg != WM_COPYDATA)
		return DefWindowProc(hwnd, msg, wp, lp);

	cds = (COPYDATASTRUCT*)lp;
	if (cds->dwData != DEBUG_CONSOLE_WM_NOTICE)
		return DefWindowProc(hwnd, msg, wp, lp);

	puts(cds->lpData);

	return 0;
}




int WINAPI
WinMain( HINSTANCE hinstance, HINSTANCE hprevinstance,
         LPSTR lpcmdline, int ncmdshow )
{
	HWND hself;
	WNDCLASS window_class;

	window_class.style = CS_HREDRAW | CS_VREDRAW;
	window_class.lpfnWndProc = window_procedure;
	window_class.cbClsExtra = 0;
	window_class.cbWndExtra = 0;
	window_class.hInstance = hinstance;
	window_class.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	window_class.hCursor = LoadCursor(NULL, IDC_ARROW);
	window_class.hbrBackground = (HBRUSH)COLOR_HIGHLIGHT;
	window_class.lpszMenuName = NULL;
	window_class.lpszClassName = DEBUG_CONSOLE_CLASSNAME;
	if (!RegisterClass(&window_class))
		die("ERROR: RegisterClass failed.");

	hself = CreateWindowEx(
		WS_EX_TOOLWINDOW,
		DEBUG_CONSOLE_CLASSNAME,
		DEBUG_CONSOLE_WINDOWNAME,
		WS_ICONIC,
		0, 0, 0, 0,
		HWND_MESSAGE,
		NULL,
		hinstance,
		NULL
	);
	if (hself == NULL) {
		UnregisterClass(DEBUG_CONSOLE_CLASSNAME, hinstance);
		die("ERROR: CreateWindowEx failed.");
	}

	puts("debug console: begin");
	while (!0) {
		MSG msg;
		BOOL r;

		r = GetMessage(&msg, hself, WM_COPYDATA, WM_COPYDATA);
		if (r != TRUE) break;

		DispatchMessage(&msg);
	}
	puts("debug console: end");

	return 0;
}




/* __END__ */
